#ifndef COM_SAXBOPHONE_MORSE_SYMBOL_HPP
#define COM_SAXBOPHONE_MORSE_SYMBOL_HPP

/**
 * @file
 *
 * @brief A simple data type used to represent the symbols of Morse Code
 *
 * @author Joshua Saxby <Joshua2.Saxby@live.uwe.ac.uk>
 * @date 2020
 *
 * Student Number 18018052
 *
 * @copyright Copyright (C) Joshua Saxby 2020
 *
 * @copyright
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

// SAXBOPHONE.COM is my domain, so I'm using the reverse form as my namespace
namespace com_saxbophone {
    /**
     * @brief Represents one symbol of Morse Code
     * @note this includes the "space" types as well as dots and dashes
     */
    enum class MorseSymbol : uint8_t {
        UNKNOWN, /**< a symbol not recognised as Morse Code */
        DOT, /**< a Dot */
        DASH, /**< a Dash */
        SPACE, /**< a space between parts of the same letter */
        LETTER_SPACE, /**< a space between letters of the same word */
        WORD_SPACE, /**< a space between words */
    };
}

#endif // include guard
