#ifndef COM_SAXBOPHONE_PULSE_HPP
#define COM_SAXBOPHONE_PULSE_HPP

/**
 * @file
 *
 * @brief POD type used for representing morse code and digital signals.
 *
 * @author Joshua Saxby <Joshua2.Saxby@live.uwe.ac.uk>
 * @date 2020
 *
 * Student Number 18018052
 *
 * @copyright Copyright (C) Joshua Saxby 2020
 *
 * @copyright
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */


// SAXBOPHONE.COM is my domain, so I'm using the reverse form as my namespace
namespace com_saxbophone {
    /**
     * @brief represents input pulses of Morse Code or digital signals.
     */
    struct Pulse {
        /**
         * @brief Whether this pulse is HI/button held down or LO/button released
         */
        bool state;
        unsigned long duration; /**< the duration of this Pulse */
    };

};

#endif // include guard
