#ifndef COM_SAXBOPHONE_ROLE_HPP
#define COM_SAXBOPHONE_ROLE_HPP

/**
 * @file
 *
 * @brief Communication role of the participating micro:bits
 *
 * @author Joshua Saxby <Joshua2.Saxby@live.uwe.ac.uk>
 * @date 2020
 *
 * Student Number 18018052
 *
 * @copyright Copyright (C) Joshua Saxby 2020
 *
 * @copyright
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

// SAXBOPHONE.COM is my domain, so I'm using the reverse form as my namespace
namespace com_saxbophone {
    /**
     * @brief Communication Role to be used by a micro:bit
     */
    enum class Role {
        UNKNOWN, /**< unknown Role (sentinel for zero-initialised data) */
        SLAVE, /**< Slave Role */
        MASTER, /**< Master Role */
    };
};

#endif // include guard
