// XXX: this is a basic test program of the MorseDecoder class, debugging only

#include <iostream>

#include "../source/MorseDecoder.hpp"


int main() {
    using namespace com_saxbophone;

    MorseDecoder decoder(100);

    struct Input {
        bool state; // whether it's on (button held) or off (button released)
        unsigned long duration; // duration of pulse in ms
    };

    // humans are inexact, so let's simulate some roughly-timed morse code
    // DOT DOT DASH DOT <WORD SPACE> = "F"
    Input inputs[] = {
        { true, 23, }, // *noise*
        { true, 123, }, // DOT
        { false, 101, }, // DOT SPACE
        { true, 114, }, // DOT
        { false, 23, }, // *noise*
        { false, 136, }, // DOT SPACE
        { true, 456, }, // DASH
        { true, 34, }, // *noise*
        { false, 141 }, // DOT SPACE
        { true, 153 }, // DOT
        { false, 777, }, // WORD SPACE
    };

    // print the value of peek()
    std::cout << decoder.peek();

    for (Input i : inputs) {
        decoder.transition(i.state, i.duration);
        // print the value of peek()
        std::cout << " " << decoder.peek();
    }

    std::cout << std::endl;

    char output = '.'; // placeholder if value not set
    if (decoder.remove_next(output)) {
        std::cout << output << std::endl;
    }
    return 0;
}
