// XXX: this is a basic test program of the MorseDecoder class, debugging only

#include <cassert>
#include <iostream>
#include <string>

#include "../source/MorseTree.hpp"


#define dot false
#define dash true


int main() {
    using namespace com_saxbophone;

    // some comprehensive unit tests to check my MorseTree decoder works
    struct test {
        char result;
        std::string input;
    };

    test tests[] = {
        { 'A', "._", },
        { 'B', "_...", },
        { 'C', "_._.", },
        { 'D', "_..", },
        { 'E', ".", },
        { 'F', ".._.", },
        { 'G', "__.", },
        { 'H', "....", },
        { 'I', "..", },
        { 'J', ".___", },
        { 'K', "_._", },
        { 'L', "._..", },
        { 'M', "__", },
        { 'N', "_.", },
        { 'O', "___", },
        { 'P', ".__.", },
        { 'Q', "__._", },
        { 'R', "._.", },
        { 'S', "...", },
        { 'T', "_", },
        { 'U', ".._", },
        { 'V', "..._", },
        { 'W', ".__", },
        { 'X', "_.._", },
        { 'Y', "_.__", },
        { 'Z', "__..", },
        { '0', "_____", },
        { '1', ".____", },
        { '2', "..___", },
        { '3', "...__", },
        { '4', "...._", },
        { '5', ".....", },
        { '6', "_....", },
        { '7', "__...", },
        { '8', "___..", },
        { '9', "____.", },
        { '!', "______", },
        { '!', "__.._", },
        { '!', "......", },
    };

    {
        for (test t : tests) {
            MorseTree tree;
            std::cout << tree.read_cursor();
            for (char c : t.input) {
                std::cout << " " << c;
                if (c == '.') {
                    tree.advance(false);
                } else if (c == '_') {
                    tree.advance(true);
                } else {
                    assert(false);
                }
                std::cout << " " << tree.read_cursor();
            }
            std::cout << std::endl;
            assert(tree.read_cursor() == t.result);
        }
    }

    return 0;
}
